
func criajogo()

/* Como demonstracao, criamos um arquivo de texto, 'SUDODEMO.TXT' com um jogo facil,
   usando os caracteres mais comuns (123456789). Usamos o caracter 'ponto'(.) para indicar
   que a casa corespondebte no tem valor proposto, e o caracter 'vrgula' (,) para indicar a separacao da
   string em blocos, a saber: 1o. bloco, as casa; 2o. bloco, os caracteres possiveis; 3o. bloco,
   nivel de dificuldade ou qualquer outra anotacao nao editavel de se queira fazer, com ate 10 caracteres
   e 4o. bloco, quaisquer anotacoes editaveis que se queira fazer. Por exemplo, 'Pag. 12 do numero 73 da
   revista Sudoku Hoje.
   
   Por isso, os caracteres 'ponto' (.) e vrgula (,) nao podem ser usados no conjunto de 9 caracteres
   que o jogo contera. Mas alm dos numerais, o mais comum  utilizar-se de letras (lembrando-se de que o
   sistema considera a mesma letra com caixas diferentes - por exemplo, A e a, como caracteres diferentes.
   Umas sugestao e no modo 'criar novo jogo via teclado', usar 9 letras que formem uma palavara na diagonal...

   Bem, criado o arquivo SUDODEMO.TXT com uma unica string, em seguida importamos o arquivo com essa
   string para os .DBFs do sistema. Nesse momento as casas que no tiverem valores propostos originalmente
   pelo problema conterao, como candidatos, todos os caracteres possiveis (nesse casao, de 1 a 9).
   
   Por isso, num terceiro passo eliminamos das casas aparentemente vazias, os candidatos 'inteis'.
   Por exemplo, se na linha 1 houver uma casa com um valor proposto, digamos o valor '3',
   eliminamos de todas as outras casas dessa linha o '3' como candidato. E fazemos o mesmo
   com a coluna e com o grupo em que essa casa esta. E em seguida, o mesmo com todas as outras casas
   com valores propostos.

   Os arquivos de texto para importacao podem conter muitos jogos. Por exemplo, se contiverem strings com
   apenas os blocos obrigatorios (o primeiro e o segundo) cada linha contera 93 bytes - 81 casas, uma vrgula,
   os 9 caracteres possiveis, CR ('return', ENTER ou chr(13)) e LF ('line feed', chr(10). Considerando
   que o arquivo texto para ser importado pelo Clipper pode ter no mximo 65.536 bytes (64Kb),
   um arquivo texto para importacao pode conter mais de 700 jogos.*/

loca linha := ''
loca adbf := {} 


// primeiro bloco: casas
linha =         '..64.51..'
linha = linha + '.........'
linha = linha + '8.29.15.4'
linha = linha + '1.7.9.2.6'
linha = linha + '...6.4...'
linha = linha + '3.5.7.4.8'
linha = linha + '4.92.37.1'
linha = linha + '.........'
linha = linha + '..15.96..'

// segundo bloco: caracteres possiveis
linha = linha + ','
linha = linha + '123456789'

// terceiro bloco: nivel
linha = linha + ','
linha = linha + 'Facil'

// quarto e ultimo bloco: observacoes, comentarios etc.
linha = linha + ','
linha = linha + 'Esse e o primeiro jogo deste programa.'
linha = linha + chr(13) + chr(10)

/* Essa string pode ser criada, na pratica, numa esticada so. Quebrar o primeiro bloco durante a digitacao
   pode, porem, ser uma boa ideia para checar erros de digitacao, desde que se lembre que 'desquebra-la
   antes de salvar o arquivo. Criemos agora o arquivo com essa string: */

memowrit('sudodemo.txt',linha)

/* Pronto, esta criado o SUDODEMO.TXT. A funcao que importa um .TXT para os DBFs do jogo, import(),
   se chamada sem parametro, importa apenas o arquivo especificado. Mas se chamada sem parametro
   constroi uma array com *.txt, exceto os arquivos de mensagens em diferentes idiomas, identificados
   por LANG???.TXT.*/

import('sudodemo.txt')
retu
