
/* Programa chamador. Faz a tela inicial, de escolha dentre os jogos cadastrados,
   oferece o ultimo jogo aberto e as opcoes para as chamadas das telas de sets do sistema,
   e a saida do sistema, alem de atalhos para alternar regua, verimode e calcand e de menu
   atraves do qual se pode inserir novo jogo (por importacao ou digitacao) e deletar o jogo
   atual. Esse menu tambem informa os atalhos para as insercoes e delecao.
*/

//  para resolver uso de 100% da CPU durante inkey(), wait, menu to, achoice etc.
//  sob o Windows NT, 2000, XP, 7 etc.
//  necessita NANFOR.LIB e CPMI.LIB
//  documentacao e download http://www.engwall.com/clipper/nfpat1a.htm
//  ft_onidle({||ft_iamidle()})

// setmode(25,80) // so quando no precisar mais do cld
// setcancel(.f.) // so durante os testes
// set path to 'c:\arquivos de programas\sudoku' // ja que temos dificuldades com long names...

set curs off
set colo to
cls

set wrap on
set score off
set date brit
set century on

set proc to arquivos
set proc to casas
set proc to importa
set proc to jogar
set proc to langs
set proc to notas
set proc to primjogo
set proc to processa
set proc to telas

publ casas := {}
criacasas()
publ diga := {}

publ xnumero := 0 // sudoku1->numero1 do ultimo jogo aberto, guardado em sets.dbf
publ xsimbol := '' // sudoku1->simbol
publ xnivel := '' // sudoku1->nivel
publ xcriacao := ctod('//') // sudoku1->criacao

publ xultmov := ctod('//') // sudoku2->ultmov
publ xultlin := '' // sudoku2->ultlin - a linha, na tela, em que o cursor estava da ultima vez
publ xultcol := '' // sudoku2->ultcol - a coluna, na tela, em que o cursor estava da ultima vez
publ xobs := '' // sudoku2->obs - notas auxiliares

publ xidioma := 'Portugues do Brasil' // sets->idioma - nome do idioma que sera usado
publ xcodidi := 'POB' // sets->codidi - codigo do idioma
publ xultjogo := 1 // sets->ultjogo - o ultimo jogo aberto
publ xverimode := .f. // sets->verimode - o ultimo set de verimode
publ xmostreg := .f. // sets->mostreg - o ultimo set de mostreg
publ xautocan := .f. // stes->autocan - o ultimo set de autocan

temsets()
temlang()
temjogo()

priv telesc := .f. // a tela de escolha ja foi desenhada?
priv teldat := .f. // a tela de dados ja foi montada?
priv pnlesc := .f. // foi desenhado o painel da tela de escolha?
priv temab := .f. // tem jogo posterior a esse?
priv temac := .f. // tem jogo anterior a esse?
priv tecasc := 0 // qual o codigo ASCII da ultima tecla pressionada?
priv tempnum := 0

clos all
use sudoku2 inde sudoku2 alias sudoku2 new
use sudoku1 inde sudoku1 alias sudoku1 new
set relation to numero1 into sudoku2

seek xultjogo      

whil .t.

   set colo to
   if telesc = .f.
      cls
      telona('w/n')
      telinha('+n/n')
      telmemo('w/n')
      telesc = .t.
   endi

   if teldat = .f.
      carrega()
      teldados('w/n')
      teldat = .t.
   endi

   if pnlesc = .f.
      tempnum = sudoku1->numero1
      skip +1
      if eof() // esse e o ultimo jogo nos dbfs?
         temab = .f.
      else
         temab = .t.
      endi
      seek tempnum
      skip -1
      if bof() // esse e o primeiro jogo nos dbfs?
         temac = .f.
      else
         temac = .t.
      endi
      seek tempnum

      if temac
         setcolor('w/bg')
      else
         setcolor('+n/n')
      endi
      @ 22,04 say ' PgUp '

      if temab
         setcolor('w/bg')
      else
         setcolor('+n/n')
      endi
      @ 22,11 say ' PgDn '

      setcolor('w/bg')
      @ 22,18 say ' ENTER '
      @ 22,27 say ' Alt-M Menu '
      setcolor('w/r')
      @ 24,30 say ' ESC Sai '
      set colo to
      @ 21,43 say diga[18] + '..........: ' + dtoc(xcriacao)
      @ 22,43 say diga[19] + '...: ' + dtoc(xultmov)
      @ 23,43 say diga[44] + ': ' + xsimbol
      pnlesc = .t.
   endi
   
   set colo to
   set curs off
   tecasc = inkey(0)
   
   if tecasc = 13
      joga(xnumero)
      telesc = .f.
      pnlesc = .f.
   elseif tecasc = 27
      pnlesc = .f.
      if esmaece(diga[3],{diga[4],diga[5]}) < 2
         exit
      endi
   elseif tecasc = 18 .and. temac // pgup
      skip -1
      if bof()
         skip + 1
      else
         pnlesc = .f.
         teldat = .f.
      endi
   elseif tecasc = 3 .and. temab // pgdn
      skip +1
      if eof()
         skip -1
      else
         pnlesc = .f.
         teldat = .f.
      endi
   elseif tecasc = 306 // alt-m - menu
   elseif tecasc = 22  // ins
      manimport()
      telesc = .f.
      teldat = .f.
      pnlesc = .f.
   elseif tecasc = 7   // del
      esmaece('Deletaria')
   elseif tecasc = 275 // alt-r - regua
      regua('g')
   endi
endd
dbcommitall()
dbcloseall()
set colo to
cls
quit

func esmaece(msg,opc)
loca val_ret := 0
loca abc := savescreen(00,00,24,79)
loca def := ''
loca ligado := .t.
loca i := 0
for i = 1 to len(abc)
   if ligado
      def = def + subs(abc,i,1)
   else
      def = def+'x'
   endi
   ligado = !ligado
next
restscreen(00,00,24,79,def)
if opc = NIL
   alert(msg)
   val_ret = 0
else
   val_ret = alert(msg,opc)
endi
restscreen(00,00,24,79,abc)
retu val_ret